<template>
  <q-page class="text-center">
    <div class="q-pa-md">
      <h2>Welcome, {{ username }}!</h2>
      <br />
      <h5>Please enter the poll token provided by your supervisor</h5>
      <div>
        <input
          class="token"
          type="text"
          id="token"
          maxlength="6"
          v-model="input"
        />
      </div>
      <div>
        <q-btn
          class="q-ma-md"
          color="black"
          text-color="white"
          label="Submit"
          @click="goToVote"
        />
      </div>
    </div>
  </q-page>
</template>

<script>
import { mapGetters } from "vuex";
import { api } from "boot/axios";

export default {
  name: "PageIndex",
  data() {
    return {
      input: ""
    };
  },
  computed: {
    ...mapGetters("user", ["username"]),
    upper() {
      return toUpperCase(this.input);
    }
  },
  methods: {
    async goToVote() {
      const request = {
        polltkn: this.input.toUpperCase(),
        token: sessionStorage.token
      };

      await api
        .post("/api/poll/checkIfPoll", request)
        .then(res => {
          console.log(res.data);
          if (res.data.pollInaccessible == true) {
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Voting is not accepted for this poll"
            });
          } else if (
            res.data.pollExists == true &&
            res.data.pollInaccessible == false
          ) {
            this.$router.push({ path: "/vote/" + request.polltkn });
          } else {
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: res.error
            });
          }
        })
        .catch(error => {
          if (error.response.status == 404)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Poll not found"
            });

          if (error.response.status == 403)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "You don't have access to this poll"
            });

          if (error.response.status == 423)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Voting is no longer accepted in this poll"
            });

          if (error.response.status == 500)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Server error"
            });
        });
    }
  }
};
</script>

<style scoped>
.q-btn {
}
.header {
  text-align: center;
}
.token {
  width: 144px;
  font-size: 24px;
  text-align: center;
  text-transform: uppercase;
}
</style>
